"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _types = _interopRequireWildcard(require("@babel/types"));
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
/**
 * Creates an AST representation of an InputObjectType shape object.
 */
const createObjectExpression = (types, object) => {
  const properties = [];
  Object.keys(object).forEach(name => {
    const value = object[name];
    let newValue;
    if (!types.isAnyTypeAnnotation(value)) {
      switch (typeof value) {
        case 'string':
          newValue = types.stringLiteral(value);
          break;
        case 'object':
          newValue = createObjectExpression(types, value);
          break;
        case 'boolean':
          newValue = types.booleanLiteral(value);
          break;
        case 'undefined':
          return;
        default:
          throw new TypeError(`Unexpected type: ${typeof value}`);
      }
    }
    properties.push(types.objectProperty(types.stringLiteral(name), newValue));
  });
  return types.objectExpression(properties);
};
var _default = exports.default = createObjectExpression;
//# sourceMappingURL=createObjectExpression.js.map